//Author:SharpPlus Software Corp.
//Standard Actions Dialog
using System;
using System.Drawing;
using System.Collections;
using System.ComponentModel;
using System.Windows.Forms;

namespace SharpPlus.Action.Design
{
	internal class StdActionForm : System.Windows.Forms.Form
	{
		private System.Windows.Forms.TreeView tvAction;
		private System.Windows.Forms.Label lbl1;
		private System.Windows.Forms.Button btnOk;
		private System.Windows.Forms.Button btnCancel;
		private System.Windows.Forms.Timer timerUpdate;
		private System.ComponentModel.IContainer components;

		public StdActionForm()
		{
			InitializeComponent();
		}

		protected override void Dispose( bool disposing )
		{
			if( disposing )
			{
				if(components != null)
				{
					components.Dispose();
				}
			}
			base.Dispose( disposing );
		}

		#region Windows Designer generated code
		private void InitializeComponent()
		{
			this.components = new System.ComponentModel.Container();
			this.tvAction = new System.Windows.Forms.TreeView();
			this.lbl1 = new System.Windows.Forms.Label();
			this.btnOk = new System.Windows.Forms.Button();
			this.btnCancel = new System.Windows.Forms.Button();
			this.timerUpdate = new System.Windows.Forms.Timer(this.components);
			this.SuspendLayout();
			// 
			// tvAction
			// 
			this.tvAction.ImageIndex = -1;
			this.tvAction.Location = new System.Drawing.Point(16, 40);
			this.tvAction.Name = "tvAction";
			this.tvAction.SelectedImageIndex = -1;
			this.tvAction.Size = new System.Drawing.Size(392, 392);
			this.tvAction.TabIndex = 0;
			this.tvAction.DoubleClick += new System.EventHandler(this.tvAction_DoubleClick);
			// 
			// lbl1
			// 
			this.lbl1.Location = new System.Drawing.Point(16, 16);
			this.lbl1.Name = "lbl1";
			this.lbl1.Size = new System.Drawing.Size(248, 16);
			this.lbl1.TabIndex = 1;
			this.lbl1.Text = "Available Standard Actions";
			// 
			// btnOk
			// 
			this.btnOk.DialogResult = System.Windows.Forms.DialogResult.OK;
			this.btnOk.Location = new System.Drawing.Point(216, 443);
			this.btnOk.Name = "btnOk";
			this.btnOk.Size = new System.Drawing.Size(88, 32);
			this.btnOk.TabIndex = 2;
			this.btnOk.Text = "Ok";
			// 
			// btnCancel
			// 
			this.btnCancel.DialogResult = System.Windows.Forms.DialogResult.Cancel;
			this.btnCancel.Location = new System.Drawing.Point(312, 443);
			this.btnCancel.Name = "btnCancel";
			this.btnCancel.Size = new System.Drawing.Size(88, 32);
			this.btnCancel.TabIndex = 3;
			this.btnCancel.Text = "Cancel";
			// 
			// timerUpdate
			// 
			this.timerUpdate.Interval = 200;
			this.timerUpdate.Tick += new System.EventHandler(this.timerUpdate_Tick);
			// 
			// StdActionForm
			// 
			this.AcceptButton = this.btnOk;
			this.AutoScaleBaseSize = new System.Drawing.Size(6, 14);
			this.CancelButton = this.btnCancel;
			this.ClientSize = new System.Drawing.Size(424, 485);
			this.ControlBox = false;
			this.Controls.Add(this.btnCancel);
			this.Controls.Add(this.btnOk);
			this.Controls.Add(this.lbl1);
			this.Controls.Add(this.tvAction);
			this.FormBorderStyle = System.Windows.Forms.FormBorderStyle.FixedDialog;
			this.MaximizeBox = false;
			this.MinimizeBox = false;
			this.Name = "StdActionForm";
			this.ShowInTaskbar = false;
			this.StartPosition = System.Windows.Forms.FormStartPosition.CenterScreen;
			this.Text = "Standard Actions";
			this.Load += new System.EventHandler(this.StdActionForm_Load);
			this.ResumeLayout(false);

		}
		#endregion

		private void timerUpdate_Tick(object sender, System.EventArgs e)
		{
			//Validate Ok
			this.btnOk.Enabled=HasValidAction();
		}

		private bool HasValidAction()
		{
			if (this.tvAction.SelectedNode==null)
				return false;
			return tvAction.SelectedNode.Tag is Type;
		}

		private void StdActionForm_Load(object sender, System.EventArgs e)
		{
			//load Action's tree
			SortedList _ActionCategories=ActionManager.GetActionCategories();
			foreach (string key in _ActionCategories.Keys)
			{
				TreeNode pNode=this.tvAction.Nodes.Add(key);
				SortedList actList=_ActionCategories[key] as SortedList;
				foreach (Type t in actList.Values)
				{
					TreeNode actNode=pNode.Nodes.Add(t.FullName);
					actNode.Tag=t;
				}
			}

			this.tvAction.ExpandAll();
		}

		private void tvAction_DoubleClick(object sender, System.EventArgs e)
		{
			//double click
			if (HasValidAction())
				this.DialogResult=DialogResult.OK;
		}

		public Type ActionType
		{
			get {return this.tvAction.SelectedNode.Tag as Type;}
		}
	}
}
